=== debian/changelog ===
rock-master-20.01-slam-gtsam (0.20160620-1~xenial) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: https://bitbucket.org/gtborg/gtsam.git
  * branch: refs/heads/master
  * commit: c21186c6212798e665da6b5015296713ddfe8c1d
  * tag: 4.0.0-alpha1

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Sun, 09 Feb 2020 01:16:51 +0100
